package com.sun.corba.se.spi.activation;

import org.omg.CORBA.BAD_OPERATION;
import org.omg.CORBA.CompletionStatus;
import com.sun.corba.se.spi.activation.InitialNameServicePackage.NameAlreadyBound;
import com.sun.corba.se.spi.activation.InitialNameServicePackage.NameAlreadyBoundHelper;
import org.omg.CORBA.ObjectHelper;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.portable.ResponseHandler;
import org.omg.CORBA.portable.InputStream;
import java.util.Hashtable;
import org.omg.CORBA.portable.InvokeHandler;
import org.omg.CORBA.portable.ObjectImpl;

public abstract class _InitialNameServiceImplBase extends ObjectImpl implements InitialNameService, InvokeHandler
{
    private static Hashtable _methods;
    private static String[] __ids;
    
    public _InitialNameServiceImplBase() {
    }
    
    public OutputStream _invoke(String key, InputStream inputStream, ResponseHandler responseHandler) {
        Integer n = (Integer)_InitialNameServiceImplBase._methods.get(key);
        if (n == null) {
            throw new BAD_OPERATION(0, CompletionStatus.COMPLETED_MAYBE);
        }
        switch ((int)n) {
            case 0: {
                OutputStream outputStream;
                try {
                    this.bind(inputStream.read_string(), ObjectHelper.read(inputStream), inputStream.read_boolean());
                    outputStream = responseHandler.createReply();
                }
                catch (NameAlreadyBound nameAlreadyBound) {
                    outputStream = responseHandler.createExceptionReply();
                    NameAlreadyBoundHelper.write(outputStream, nameAlreadyBound);
                }
                return outputStream;
            }
            default: {
                throw new BAD_OPERATION(0, CompletionStatus.COMPLETED_MAYBE);
            }
        }
    }
    
    public String[] _ids() {
        return (String[])(String[])_InitialNameServiceImplBase.__ids.clone();
    }
    
    static {
        (_InitialNameServiceImplBase._methods = new Hashtable()).put("bind", new Integer(0));
        _InitialNameServiceImplBase.__ids = new String[] { "IDL:activation/InitialNameService:1.0" };
    }
}
